/***************************************************************************
                          qmain.cpp  -  description
                             -------------------
    begin                : ven avr 12 18:55:44 CET 2002
    copyright            : (C) 2002 by Romain Vinot
    email                : vinot@aist.enst.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef _WIN32
#pragma warning (disable : 4786)
#endif

#include <iostream>
#include <stdlib.h>
#include <algorithm>
#include <functional>


#include <qapplication.h>
#include <qmultilinedit.h>
#include <qdir.h>

#include "qpixmapboard.h"
#include "qcommandline.h"
#include "qcreature.h"
#include "gamemanager.h"

#include "qinterfaceimpl.h"
#include "qapplicationwindow.h"

#include "qsoundsystem.h"

Board *board;
GameManager *man;
SoundSystem *sound;

int main( int argc, char* argv[] )
{

  // Create the window application.
  QApplication app( argc, argv );
  ApplicationWindow * mw = new ApplicationWindow();
  mw->setCaption( "QSpaceHulk - The ultimate conversion" );
  app.connect( &app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()) );

  // Create the global entity : board. 
  board = new Board();  

  // Create the global entity : sound
  sound = new QtSoundSystem;

  QInterfaceImpl *main = mw->getMainWindow(); 
  QPixmapBoard *qboard = main->getPixmapBoard();

  QCreature *guic = new QCreature(main); 
  
  QCommandLine cmd(qboard, guic, main);
  main->setCommandLine(&cmd);
  
  man = new GameManager(guic, qboard, &cmd);
  cmd.DrawInterface();
  mw->show();

  app.exec();
  cmd.endOfExecution();
  return 0;
}

