/* -*- c++ -*- */
/***************************************************************************
                         variables.h  -  description
                             -------------------
    begin                : ven mar 15 10:49:00 CET 2002
    copyright            : (C) 2002 by Romain Vinot
    email                : vinot@aist.enst.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _VARIABLES_H_
#define _VARIABLES_H_

#ifdef _WIN32
#define DIR_DELIMITER '\\'
#else
#define DIR_DELIMITER '/'
#endif

class Object;

enum Turn { GENESTEALER_TURN, MARINE_TURN, CAT_TURN };

enum ObjectType { EXTENSIBLE, DOOR, BULKHEAD, ENTRYZONE, EXIT, FLAME, CAT, 
		  GENESTEALER, BLIP, BOLTERMARINE, SERGEANT, FLAMER,
		  NB_OBJECT_TYPE };
enum DoorState { OPEN, CLOSE };

enum historyCmd { NONE, TURN90, TURN180, FORWARD, BACKWARD, SHOOT, OVERWATCH,
		  FIRE};

enum Direction { NORTH, SOUTH, EAST, WEST, NODIRECTION };
enum FullDirection { NORTHNORTH, NORTHEAST, EASTEAST, SOUTHEAST, SOUTHSOUTH,
		     SOUTHWEST, WESTWEST, NORTHWEST };
enum RelativeDirection { FRONT, BACK, SIDE };

enum interfaceState { GUI_WAITING, GUI_SHOOT, GUI_FIRE, GUI_REVERT };

struct AttackRes {
  bool attackEnable;
  int resAttack;
  Object *def;

  AttackRes(bool b, int r, Object *d) 
    : attackEnable(b), resAttack(r), def(d) {}
};

// This priotity is needed for viewing on the board and in the 'onView panel'
inline int getPriority(ObjectType type)
{
  switch (type) {
  case DOOR: return 20;
  case CAT: case EXTENSIBLE: return 25;
  case GENESTEALER: case BLIP: case BOLTERMARINE: case SERGEANT: case FLAMER:
    return 30;
  case FLAME: return 50;
  case ENTRYZONE: case EXIT: return 60;
  case BULKHEAD: return 70;
  default: return 0;
  }
};

inline FullDirection Dir2FullDir(Direction dir)
{
  switch(dir) {
  case NORTH: return NORTHNORTH;
  case SOUTH: return SOUTHSOUTH;
  case WEST: return WESTWEST;
  case EAST: return EASTEAST;
  default: return NORTHNORTH;
  }
  return NORTHNORTH;
}
#endif
